---
updatedAt: 2026-04-27T16:08:18.000Z
agentTools:
  projectIndex: https://docs.ol-hub.com/llms.txt
---

# create module by solution

The **create module by solution** API sends a POST request to create a module using solution center.

**Prerequisites**

* The caller must provide a **module name**  of at least 3 characters.
* The caller must provide a preexisting **solution name**.

**Authorization**

* API key (via the `X-API-KEY` header).

### Parameters

<Accordion title="Request Body">
  | Field name       | Description              | Format |
  | :--------------- | :----------------------- | :----- |
  | **moduleName**   | The name of the module   | String |
  | **solutionName** | The name of the solution | String |
</Accordion>

<Accordion title="Response Body">
  | Field name | Description            | Format |
  | :--------- | :--------------------- | :----- |
  | **id**     | The id of the module   | String |
  | **name**   | The name of the module | String |
</Accordion>

### Examples

<Tabs>
  <Tab title="mainframe-rpc">
    ```json Request
    {
      "solutionName": "account-cics-demo",
      "moduleName": "module-by-solution-mainframe-rpc"
    }
    ```
    ```json Response
    {
      "id": "00000000-0000-0000-0001-000000000011",
      "name": "module-by-solution-mainframe-rpc"
    }
    ```
  </Tab>

  <Tab title="as400-rpc">
    ```json Request
    {
      "solutionName": "account-as400-pcml",
      "moduleName": "module-by-solution-as400-rpc"
    }
    ```
    ```json Response
    {
      "id": "00000000-0000-0000-0002-000000000022",
      "name": "module-by-solution-as400-rpc"
    }
    ```
  </Tab>

  <Tab title="ims-rpc">
    ```json Request
    {
      "solutionName": "account-ims",
      "moduleName": "module-by-solution-ims-rpc"
    }
    ```
    ```json Response
    {
      "id": "00000000-0000-0000-0003-000000000033",
      "name": "module-by-solution-ims-rpc"
    }
    ```
  </Tab>
</Tabs>

# OpenAPI definition

```json
{
  "openapi": "3.0.0",
  "info": {
    "version": "1.0.0",
    "title": "public-apis-backend"
  },
  "servers": [
    {
      "url": "https://api.ol-hub.com/backend"
    }
  ],
  "paths": {
    "/api/v1/modules/create-by-solution": {
      "post": {
        "description": "The **create module by solution** API sends a POST request to create a module using solution center.",
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "examples": {
                  "OK - Mainframe RPC": {
                    "summary": "OK - Mainframe RPC",
                    "value": {
                      "id": "00000000-0000-0000-0001-000000000011",
                      "name": "module-from-solution-mainframe-rpc"
                    }
                  },
                  "OK - AS400 RPC": {
                    "summary": "OK - AS400 RPC",
                    "value": {
                      "id": "00000000-0000-0000-0002-000000000022",
                      "name": "module-from-solution-as400-rpc"
                    }
                  },
                  "OK - IMS RPC": {
                    "summary": "OK - IMS RPC",
                    "value": {
                      "id": "00000000-0000-0000-0003-000000000033",
                      "name": "module-from-solution-ims-rpc"
                    }
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "id": {
                      "type": "string",
                      "example": "b688b49e-1039-4647-b75c-03e39e935fd3"
                    },
                    "name": {
                      "type": "string",
                      "example": "module-from-solution-mainframe-rpc"
                    }
                  }
                }
              }
            }
          }
        },
        "parameters": [],
        "operationId": "post_api-v1-modules-create-by-solution",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "type": "object",
                "properties": {
                  "moduleName": {
                    "type": "string"
                  },
                  "solutionName": {
                    "type": "string"
                  }
                },
                "required": [
                  "moduleName",
                  "solutionName"
                ]
              },
              "examples": {
                "Example - Mainframe RPC": {
                  "summary": "Example - Mainframe RPC",
                  "value": {
                    "solutionName": "account-cics-demo",
                    "moduleName": "module-from-solution-mainframe-rpc"
                  }
                },
                "Example - AS400 RPC": {
                  "summary": "Example - AS400 RPC",
                  "value": {
                    "solutionName": "account-as400-pcml",
                    "moduleName": "module-from-solution-as400-rpc"
                  }
                },
                "Example - IMS RPC": {
                  "summary": "Example - IMS RPC",
                  "value": {
                    "solutionName": "account-ims",
                    "moduleName": "module-from-solution-ims-rpc"
                  }
                }
              }
            }
          }
        },
        "summary": "create module by solution"
      }
    }
  },
  "x-readme": {
    "explorer-enabled": true,
    "proxy-enabled": true
  }
}
```